function varargout = ObjectRecoloringGUI(varargin)
% OBJECTRECOLORINGGUI MATLAB code for ObjectRecoloringGUI.fig
%      OBJECTRECOLORINGGUI, by itself, creates a new OBJECTRECOLORINGGUI or raises the existing
%      singleton*.
%
%      H = OBJECTRECOLORINGGUI returns the handle to a new OBJECTRECOLORINGGUI or the handle to
%      the existing singleton*.
%
%      OBJECTRECOLORINGGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OBJECTRECOLORINGGUI.M with the given input arguments.
%
%      OBJECTRECOLORINGGUI('Property','Value',...) creates a new OBJECTRECOLORINGGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ObjectRecoloringGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ObjectRecoloringGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ObjectRecoloringGUI

% Last Modified by GUIDE v2.5 16-Apr-2013 19:26:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ObjectRecoloringGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @ObjectRecoloringGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ObjectRecoloringGUI is made visible.
function ObjectRecoloringGUI_OpeningFcn(hObject, eventdata, handles, varargin)
 
    % Choose default command line output for ObjectRecoloringGUI
    handles.output = hObject;
    % Update handles structure
    guidata(hObject, handles);

    % INITIALIZATION -----------------------------
    set(handles.imRecolored,'HandleVisibility','ON');
    axes(handles.imRecolored);
    axis equal;
    axis tight;
    axis off;
    set(handles.imRecolored,'HandleVisibility','OFF');
    set(handles.imReconstructed,'HandleVisibility','ON');
    axes(handles.imReconstructed);
    axis equal;
    axis tight;
    axis off;
    set(handles.imReconstructed,'HandleVisibility','OFF');
    % Get the string from imageLabel. It is a standard way to get the value from the Edit box
    imageFile = get(handles.imageLabel,'String');
    originalFile = ['Images/' imageFile '.jpg'];
    % Make sure there is some file name in the Edit box
    if exist(originalFile,'file')
        % Using Matlab function to read the  image. “char” transfers the string type to char type
        original = imread(char(originalFile));
        %original = double(original);
        % Active the imOriginal axes. Again, it is a standard GUI commands
        set(handles.imOriginal,'HandleVisibility','ON');
        % Show the image in the axes. Similar as Figure(number), or
        % subplot(number1, numerber2, number 3) to make sure the image is
        % ploted/showed in the right window/sub image
        axes(handles.imOriginal);
        % Normal Matlab function to show image
        image(original);
        % Sets the aspect ratio. (Show the image in its right ratio)
        axis equal;
        % Sets the axis limits to the arrange of the data
        axis tight;
        % Turn off all axis labeling
        axis off;
        % After showed the image, let to be unchangeable until the commands set it ‘ON’
        set(handles.imOriginal,'HandleVisibility','OFF');
    end;
    % Do the same for the mask
    maskFile = ['Images/' imageFile '.bmp'];  
    if exist(maskFile,'file')
        mask = imread(char(maskFile));
        mask = cat(3,logical(mask),logical(mask),logical(mask));
        set(handles.imMask,'HandleVisibility','ON');
        axes(handles.imMask);
        image(mask);
        axis equal;
        axis tight;
        axis off;
        set(handles.imMask,'HandleVisibility','OFF');
    end;
    handles=guidata(hObject);
    handles.state = 0;
    handles.image = original;
    handles.mask = mask;
    guidata(hObject, handles);
    % --------------------------------------------

% --- Outputs from this function are returned to the command line.
function varargout = ObjectRecoloringGUI_OutputFcn(hObject, eventdata, handles) 
    % Get default command line output from handles structure
    varargout{1} = handles.output;


% --- Executes on button press in loadImageButton.
function loadImageButton_Callback(hObject, eventdata, handles)

    % Change Image -------------------------------
    % Get the string from imageLabel
    imageFile = get(handles.imageLabel,'String');
    originalFile = ['Images/' imageFile '.jpg'];
    % Make sure there is some file name in the Edit box
    if exist(originalFile,'file')
        original = imread(char(originalFile));
        set(handles.imOriginal,'HandleVisibility','ON');
        axes(handles.imOriginal);
        image(original);
        axis equal;
        axis tight;
        axis off;
        set(handles.imOriginal,'HandleVisibility','OFF');
    end;    
    % Change Mask --------------------------------
    maskFile = ['Images/' imageFile '.bmp'];
    if exist(maskFile,'file')
        mask = imread(char(maskFile));
        mask = cat(3,logical(mask),logical(mask),logical(mask));
        set(handles.imMask,'HandleVisibility','ON');
        axes(handles.imMask);
        image(mask);
        axis equal;
        axis tight;
        axis off;
        set(handles.imMask,'HandleVisibility','OFF');
    end;
    handles=guidata(hObject);
    handles.image = original;
    handles.mask = mask;
    guidata(hObject, handles);
    set(handles.saveRecon,'Visible','OFF');
    set(handles.saveRecol,'Visible','OFF');
    set(handles.imReconstructed,'Visible','OFF');
    set(handles.imRecolored,'Visible','OFF');
    % --------------------------------------------
    
% --- Executes on button press in recolor.
function recolor_Callback(hObject, eventdata, handles)
    % Ask user for color
    color = uisetcolor();
    color = uint8(color*255);
    % Apply and show the recolored image
    originalFile = get(handles.imageLabel,'String');
    imageFile = ['Images/' originalFile '.jpg'];
    maskFile = ['Images/' originalFile '.bmp'];
    
    if (exist(imageFile,'file'))&&(exist(maskFile,'file'))
        % Recolored image
        imRecolored = ObjectRecoloring(imageFile,maskFile,'color',color);
        set(handles.imRecolored,'HandleVisibility','ON');
        axes(handles.imRecolored);
        image(imRecolored);
        axis equal;
        axis tight;
        axis off;
        set(handles.imRecolored,'HandleVisibility','OFF');
        % Reconstructed image
        imReconstructed = ObjectRecoloring(imageFile,maskFile);
        set(handles.imReconstructed,'HandleVisibility','ON');
        axes(handles.imReconstructed);
        image(imReconstructed);
        axis equal;
        axis tight;
        axis off;
        set(handles.imReconstructed,'HandleVisibility','OFF');
    end;
    handles=guidata(hObject);
    handles.state = 1;
    handles.recol = imRecolored;
    handles.recon = imReconstructed;
    guidata(hObject, handles);
    set(handles.saveRecon,'Visible','ON');
    set(handles.saveRecol,'Visible','ON');
    % --------------------------------------------

function imageLabel_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function imageLabel_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in saveRecon.
function saveRecon_Callback(hObject, eventdata, handles)
    handles=guidata(hObject);
    state = handles.state;
    if (state==1)
        imReconstructed = handles.recon;
        guidata(hObject, handles);
        [FileName, PathName] = uiputfile('*.jpg', 'Save As');
        if PathName==0
            return;
        end
        Name = fullfile(PathName,FileName);
        imwrite(imReconstructed, Name, 'jpg');
    end
    % --------------------------------------------


% --- Executes on button press in saveRecol.
function saveRecol_Callback(hObject, eventdata, handles)
    handles=guidata(hObject);
    state = handles.state;
    if (state==1)
        imRecolored = handles.recol;
        guidata(hObject, handles);
        [FileName, PathName] = uiputfile('*.jpg', 'Save As');
        if PathName==0
            return;
        end
        Name = fullfile(PathName,FileName);
        imwrite(imRecolored, Name, 'jpg');
    end
    % --------------------------------------------
